Package org.iirds.dita.ot.plugin.spi

# Interface IRIHandler

All Known Implementing Classes:
  `CompositeIRIHandler`, `DefaultIRIHandler`, `FallbackIRIHandler`

public interface IRIHandler
Calculate IRIs for use in in iiRDS RDF

Author:
  Martin Kreutzer, Empolis Information Management GmbH

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `getDocumentOrTopicIRI(ToCNode node)`
  Generate IRI for a an iiRDS Topic or Document.
  `String`
  `getInfoObjectIRI(ToCNode node)`
  Generate IRI for a an iiRDS InformationObject.
  `String`
  `getMetadataIRI(ToCNode node, String classURI, String label, String context)`
  Generate IRI for a a metadata string property.
  `String`
  `getName()`
  The unique name of this IRI provider
  `String`
  `getPackageIRI(ToCNode node)`
  Generate IRI for a an iiRDS Package.

- ## Method Details

  - ### getName

    String getName()
    The unique name of this IRI provider
    Returns:
      the name of this handler

  - ### getInfoObjectIRI

    String getInfoObjectIRI(ToCNode node)
    Generate IRI for a an iiRDS InformationObject. Implementation may use external services to lookup IRIs or use properties of the node
    Parameters:
      `node` - the node for which to generated
    Returns:
      the generated IRI as String or null

  - ### getDocumentOrTopicIRI

    String getDocumentOrTopicIRI(ToCNode node)
    Generate IRI for a an iiRDS Topic or Document. Implementation may use external services to lookup IRIs or use properties of the node
    Parameters:
      `node` - the node for which to generated
    Returns:
      the generated IRI as String or null

  - ### getPackageIRI

    String getPackageIRI(ToCNode node)
    Generate IRI for a an iiRDS Package. Implementation may use external services to lookup IRIs or use properties of the node
    Parameters:
      `node` - the node for which to generated (usually the root node)
    Returns:
      the generated IRI as String

  - ### getMetadataIRI

    String getMetadataIRI(ToCNode node, String classURI, String label, String context)
    Generate IRI for a a metadata string property. Implementation may use external services to lookup IRIs or use properties of the node
    Parameters:
      `node` - the node the metadata belongs to
      `classURI` - the URI of the RDF metadata class
      `label` - something like a label of metadata value
      `context` - an additional context, usually the property name at the node hinting the source of the metadata value
    Returns:
      the generated IRI as String